angular
  .module \app
  .controller do
     * \byactivity
     ByActivityController

!function ByActivityController $scope, $root-scope, $state, $filter, $xabl, activityWidget, ablConstants, debug
    vm = this
    vm.loading = true
    vm.page = \byactivity
    vm.activityById = activityById
    
    load-operator!
    !function load-operator
      #call to api
      $xabl.get("operators/" + $state.params.merchant).then ((response1)!->
        data1 = response1.data
        if data1.currency
            $root-scope.currency = data1.currency
        else
          $root-scope.currency = "usd"
        activityById() ), (error)!->
        vm.status = \error
        vm.message = ablConstants.getPageErrorMessages!
        vm.loading = false
    
    !function activityById void
        #call to api
        $xabl.options.key = $state.params.merchant;
        $xabl.get "activities/" + $state.params.activity
        .then do
            (resps1)!->
                data = resps1.data
                $root-scope.user = 
                  preferences: data.operator.preferences
                vm.theme = if typeof data.operator.preferences.widget.display.theme is 'undefined' then default-theme else data.operator.preferences.widget.display.theme 
                vm.operator = data.operator
                vm.activity = {};
                vm.activity.activityId = data._id
                vm.activity.title = data.title
                ablConstants.setCompanyName vm.operator.companyName
                vm.activity.description = data.description
                vm.activity.location = data.location
                vm.activity.timeslots = data.timeslots.filter (timeslot) ->
                    return moment(timeslot.endTime).isAfter(moment())
                vm.activity.allRequirementsConstants = ablConstants.getAllRequirements()
                vm.activity.allRequirements = []
                vm.activity.allRequirements.push {id:'requirements', name:data.requirements} if data.requirements.length > 0
                vm.activity.allRequirements.push {id:'whatIncluded', name:data.whatIncluded} if data.whatIncluded.length > 0
                vm.activity.allRequirements.push {id:'whatToBring', name:data.whatToBring} if data.whatToBring.length > 0
                vm.activity.images = data.images
                vm.loading = false
                #set activity loaded 
                activityWidget.setCurrentActivity(data)
            (error)!->
              vm.status = \error
              vm.message = ablConstants.getPageErrorMessages!
              vm.loading = false
    getRequirementLabel = (obj) ->
      label = $filter('filter')(vm.activity.allRequirementsConstants , {id:obj.id})[0].label
    vm.getRequirementLabel = getRequirementLabel
                    