angular
  .module \app
  .controller do
     * \byevent
     ByEventController

!function ByEventController $scope, $root-scope, $state, $xabl, $filter, $location, activityWidget, ablConstants, debug
    vm = this
    vm.loading = true
    vm.page = \byevent
    vm.eventId = $state.params.event
    vm.eventById = eventById
    vm.goToActivity = goToActivity
    
    load-operator!
    !function load-operator
      #call to api
      $xabl.get("operators/" + $state.params.merchant).then ((response1)!->
        data1 = response1.data
        if data1.currency
            $root-scope.currency = data1.currency
        else
          $root-scope.currency = "usd"
        vm.currency = $root-scope.currency
        eventById() ), (error)!->
        vm.status = \error
        vm.message = ablConstants.getPageErrorMessages!
        vm.loading = false
    
    !function eventById void
        #call to api
        $xabl.options.key = $state.params.merchant;
        $xabl.get "events/" + $state.params.event
        .then do
            (resps1)!->
                data = resps1.data
                #debug \data data
                vm.activity = data.activity
                vm.event = data.event
                vm.event.start-time = moment(vm.event.start-time).tz(vm.activity.time-zone).format('dddd, MMMM Do, YYYY @ h:mmA z')
                vm.event.end-time = moment(vm.event.end-time).tz(vm.activity.time-zone).format('dddd, MMMM Do, YYYY @ h:mmA z')
                vm.eventId = data.event.eventInstanceId
                vm.timeslot = data.timeslot
                vm.charges = $filter('orderBy')(vm.timeslot.charges, '-isDefault')
                $xabl.get "activities/" + data.activity._id
                .then do
                  (resps2)!->
                    data2 = resps2.data
                    $root-scope.user = 
                      preferences: data2.operator.preferences
                    vm.activity.location = data2.location
                    vm.theme = if typeof data2.operator.preferences.widget.display.theme is 'undefined' then default-theme else data2.operator.preferences.widget.display.theme 
                    vm.operator = data2.operator
                    ablConstants.setCompanyName vm.operator.companyName
                    vm.operator.location = data2.location
                    vm.activity.allRequirementsConstants = ablConstants.getAllRequirements()
                    vm.activity.allRequirements = []
                    vm.activity.allRequirements.push {id:'requirements', name:data2.requirements} if data2.requirements.length > 0
                    vm.activity.allRequirements.push {id:'whatIncluded', name:data2.whatIncluded} if data2.whatIncluded.length > 0
                    vm.activity.allRequirements.push {id:'whatToBring', name:data2.whatToBring} if data2.whatToBring.length > 0
                    vm.loading = false
                  (error)!->
                    vm.status = \error
                    vm.message = ablConstants.getPageErrorMessages!
                    vm.loading = false
                    return
            (error)!->
              vm.status = \error
              vm.message = ablConstants.getPageErrorMessages!
              vm.loading = false
              return
    !function goToActivity
      $location.path '/merchant/'+$state.params.merchant+'/activity/'+$state.params.activity
    getRequirementLabel = (obj) ->
      label = $filter('filter')(vm.activity.allRequirementsConstants , {id:obj.id})[0].label
    vm.getRequirementLabel = getRequirementLabel