angular
  .module \app
  .directive do 
     * \calendar
     CalendarDirective
  .directive do 
     * \calendarDay
     CalendarDayDirective
     
function CalendarDirective activity-widget, $state, debug
  directive =
    restrict: \E
    template-url: \calendar
    scope:
      * activity:'='
    controller: controller
    
  !function controller $scope
    $scope
        ..model = -> activity-widget.slot
        ..block-back = activity-widget.disallowed-discovery
        ..widget = activity-widget
  directive
  
function CalendarDayDirective $state, debug
  directive =
    restrict: \A
    link:link
  !function link scope, element, attrs 
    scope.selectDay = selectDay
    !function selectDay (day)
      disabled = scope.model().isDisabledDay(day)
      if !disabled
        scope.model().selectDay day
  directive