angular
  .module(\app)
  .service do 
    * \ablConstants
    AblConstants
    
function AblConstants $rootScope, $state, debug
  companyName = ''
  getAllActivitiesPage = ->
      url: \/#/merchant/ + $state.params.merchant
      text: 'See all activities'
  getAllRequirements = ->
      options =
        * {id:"requirements", label:"Requirements:"}
          {id:"whatToBring", label:"What To Bring:"}
          {id:"whatIncluded", label:"What's Included:"}
  setCompanyName = (name) ->
    $rootScope.$broadcast 'title:updated', name
  getPageErrorMessages = ->
    messages = 
      {title:'Ooops! There is something wrong with the URL you have entered.', text:'Please go back to the operators website and contact them about the issue'}
  {
    getAllActivitiesPage = getAllActivitiesPage
    setCompanyName = setCompanyName
    getAllRequirements = getAllRequirements
    getPageErrorMessages = getPageErrorMessages
  }