angular
  .module(\app)
  .service do
    * \activityWidget
    * ($xabl, p, debug, $root-scope, ablbook, ablslot, $window, $q)->          
          change-observers = []
          get-param = (name)->
            switch name 
              case \event
                return "ue5bkikrdfujs9nsiuj8titvso_20160430T070000Z"
          widget =
            view: \calendar
            setup: (options)->
              $xabl.setup do
               * key:$state.params.merchant
               * secure:false
            screen: \loading
            disallow-discovery: ->
                widget.disallowed-discovery = yes
            current-activity: null
            disallowed-discovery: no
            # connect sdk ------------------------------------------------------
            set-current-activity: (activity)->
                return if !activity?
                widget.current-activity = activity
                widget.book =
                      ablbook activity, (status, data)->
                        if status is \success
                           widget.change \success
                        if status is \slot-chosen and data
                           widget.change \pricing
                widget.slot = ablslot activity, widget.book.calendar
                $root-scope.chosen-event = widget.slot.is-chosen-event!
                widget.slot.observe (name)->
                    switch name
                        case \event-not-found
                           widget.change \not-found
                        case \event-sold-out
                           widget.change \sold-out
                        case \event-too-close
                           widget.change \too-close
                widget.title!
            title: (name)->
              items = 
                 * [\gallery, "Select activity", no]
                 * [\calendar, "Select Day", !get-param("event")?]
                 * [\timeslots, "Select Time", !get-param("event")?]
                 * [\pricing, "Select Quantity", yes]
                 * [\details, "Personal Information", yes]
                 * [\review, "Checkout", yes]
                 * [\success, "Confirmation", no]
              enabled-items = 
                    items |> p.filter (.2) 
                          |> p.map (-> [it.0, it.1]) 
              pages = items |> p.map (-> [it.0, it.1]) |> p.pairs-to-obj
              title = pages[name] ? name
              page =
                enabled-items |> p.find (.0 is name) |> (-> enabled-items.index-of(it) + 1)
              
              $root-scope.title = 
                 | name is title => title
                 | page is 0 => title
                 | _ => "#{title} (#{page} of #{enabled-items.length})"
            on-change: (func)->
                change-observers.push func
            change: (name)->
                  #console.log('change: ', name)
            possible-activities: []
          state = 
             page: 0
             location: []
          widget